<?php
require_once '../init.php';
if (!\User::getInstance()->isLogged()) {
    header('Location: ../../logout/?' .$_SERVER['REQUEST_URI']);
    die('Cannot authorize the user');
}

$debug = isset($_REQUEST['debug']);

$cdrviewVersion = "5.01.20200402.2";
if($cdrviewVersion == "make_pack_cdrviewversion"){
	$cdrviewVersion = '4.01.38901.05';
}

$server_date = date('D M d Y H:i:s');
$serial = \Models\PBX::getInstance()->getSerial();

//Check if language file exists
$langJs = 'lang_'.\User::getInstance()->getLanguage().'.js';
if (!file_exists( __DIR__.DIRECTORY_SEPARATOR.$langJs ))
        $langJs = 'lang_en.js';

// period from cticonnectdb -> cdr_periods;

$userData = array(
        'name' => \User::getInstance()->getName(),
        'canUse' => \User::getInstance()->canUse('CTI_CDR_VIEW'),
        'canSeeAll' => \User::getInstance()->can('SEE_CDRVIEW_DIGITS'),
        'haveLicense' => \Wildix\License::getInstance()->haveLicense('cti_cdr_view'),
        'faxAvailable' => \Wildix\License::getInstance()->haveLicense('faxes'),
        'period'=> '7',
        'sla_period' => '20',
        'miss_call_sec_period' => '0',
        'uid' => \User::getInstance()->getID(),
        'hide_dig' => '0'
);

$cdrviewSettings = \Wildix\CDRView::getInstance()->getSettings(\User::getInstance());
$wmsCdrSettings  = \CDR::getInstance()->getSettings();

if($wmsCdrSettings && isset($wmsCdrSettings['general']) && isset($wmsCdrSettings['general']['hide_dig'])) {
    $userData['hide_dig'] = $wmsCdrSettings['general']['hide_dig'];
}

if(!empty($cdrviewSettings)){
	$userData = array_merge($userData, $cdrviewSettings);
	unset($userData['id']);
}

?>
<!DOCTYPE html>
<html>
    <head>
        <title>CDR View</title>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" href="misc/css/bootstrap.css" type="text/css" media="all" />
        <link rel="stylesheet" href="../../css/wildix-font.css?<?=$cdrviewVersion;?>" type="text/css" />
        <link rel="stylesheet" href="../../css/wildix-icons.css?<?=$cdrviewVersion;?>" type="text/css" />

        <script type="text/javascript">
            var Debug = <?echo ($debug)?'true':'false';?>;
            var remoteHost = '<?php echo \Wildix\CDRView::getInstance()->getRemoteHost(); ?>';
            var User = <?=json_encode($userData);?>;
            var Serial = "<?=$serial;?>";
            var CDRViewVersion = "<?=$cdrviewVersion;?>";

            var server_date = new Date('<?=$server_date;?>');
            var client_date = new Date();

            function isRemoteMode() {
                return Boolean(remoteHost);
            }

            User.serviceToken = '';
            User.fetchCount = 0;
            User.fetchToken = function() {
                this.serviceToken = '';
                return fetch('/api/v1/personal/token/')
                    .then(response => response.json())
                    .then(({result}) => {
                        return fetch(`${window.remoteHost}/api/v1/token/`, {headers: {'authorization': `Bearer ${result.token}`}})
                            .then(response => response.json());
                    })
                    .then(({result}) => {
                        this.serviceToken = result.token;
                        return result;
                    })
                    .catch(e => {
                        this.fetchCount++;
                        if(this.fetchCount >= 4) {
                            Ext.create('App.view.bootstrap.ErrorNotAllowed', { renderTo: this.bootMask, reason: 'Access denied' });
                            document.getElementById('boot-mask').style.visibility = 'visible';
                        }
                    });
            };
            User.getToken = function() {
                if (this.serviceToken) {
                    return new Promise(resolve => resolve({'token': this.serviceToken}))
                }
                return this.fetchToken();
            };
            if(isRemoteMode()) {
                User.fetchToken();
            }

            function get_current_time() {
                if (!window['Ext']) {
                    return false;
                }

                var now = Ext.Date.format(new Date(), "U");
                var diff = parseInt(now) - parseInt(Ext.Date.format(client_date, "U"));
                var time = parseInt(Ext.Date.format(server_date, "U")) + diff;

                return time;
            }

            function get_current_date() {
                if (!window['Ext']) {
                    return false;
                }

                return Ext.Date.parse(get_current_time(), "U");
            }

            function get_current_day() {
                if (!window['Ext']) {
                    return false;
                }

                var date = Ext.Date.parse(get_current_time(), "U");
                var day = Ext.Date.format(date, "Y-m-d");

                return day;
            }

            function hide_acl_digits(value) {
                if(!User.canSeeAll && User.hide_dig > 0 && value.length > 7) {
                    var hide_num = User.hide_dig;
                    if(value.length < User.hide_dig) { hide_num = value.length; }
                    return value.slice(0, -hide_num) + '*'.repeat(hide_num);
                }
                return value;
            }
            function hide_acl_name(name, value) {
                if(!User.canSeeAll && User.hide_dig > 0 && value.length > 7) {
                    return name ? name.replace(/\w?/g, "*") : false;
                }
                return name;
            }

            String.prototype.repeat = function( num )
            {
                num = parseInt(num);
                return new Array( num + 1 ).join( this );
            };
        </script>
		<script type="text/javascript" src="../../js/jquery-3.2.0.min.js"></script>
        <script type="text/javascript" src="../../js/ReconnectingWebSocket.js"></script>
        <script type="text/javascript" src="../../js/Wildix/Settings.js"></script>
        <script type="text/javascript" src="../../js/Wildix/Events.js"></script>
        <script type="text/javascript" src="../../js/Wildix/Integration.js"></script>
        <?php if($debug){?>
        <script type="text/javascript" src="app/sprintf.js"></script>
        <script type="text/javascript" src="app/es6-promise.min.js"></script>
        <script type="text/javascript" src="translation/lang-<?=\User::getInstance()->getLanguage();?>.js"></script>
        <script type="text/javascript" src="app/bootstrap.js"></script>
        <script type="text/javascript" src="app/xlsx.core.js"></script>
        <?php }else{?>
        <script type="text/javascript" src="bootstrap.js?<?=$cdrviewVersion;?>"></script>
        <?php }?>

    </head>
    <body onload="boot()">
        <div id="boot-mask"></div>
        <div id="boot-loader"></div>
        <script type="text/javascript">
            boot_notification();
        </script>

        <link rel="stylesheet" href="resources/css/ext-all-gray.css" type="text/css" media="all" />
        <link rel="stylesheet" href="misc/css/style.css" type="text/css" media="all" />

        <?php if($debug){?>
        <script type="text/javascript" src="ext-all-dev.js"></script>
        <script type="text/javascript" src="app/app.js"></script>
        <script type="text/javascript" src="app/locale/ext-lang-en.js"></script>
        <?php }else{?>
        <script type="text/javascript" src="ext-all.js?<?=$cdrviewVersion;?>"></script>
        <script type="text/javascript" src="<?=$langJs;?>?<?=$cdrviewVersion;?>"></script>
        <script type="text/javascript" src="app.js?<?=$cdrviewVersion;?>"></script>
        <?php }?>
    </body>
</html>
